/**************************************************************************
       fmlanguage.cpp  -  initializing char * for user communication
                             -------------------
    begin                : May 10th 2002
    copyright            : (C) 2002 by Daniel Gruen
    email                : daniel_gruen@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "include/fmlanguage_fmfile.h"
#include <cstring>

text_fmfile::text_fmfile() {
	title = "FMFile-Generator";
	syntax2 = " [filename]";
	start = "Fmfile will read your data now.";
	mode = "saving mode: ";
	modes1 = "the modes are:";
	modes2 = "\t(1) every value\n\t(2) peak values, connected with lines or sine curves\n\t(3) midi-like mode for frequency files\n\t(4) fourier synthesis mode\n";
	modes3 = "mode: ";
	name = "name for frequency module (up to 255 characters, last character \".\"): ";
	values = "number of values (default 4410): ";
	otnr   = "number of overtones: ";
	bytes = "bytes per value (Default 1): ";
	onebyte = "Only one byte per value supported yet. Set to one byte per value";
	error = "Unexpected error!";
	usephase = "Do you want to use phases (y/n)? ";
	otamp1 = "amplitude for overtone ";
	otamp2 = ": ";
	otphase = "phase: ";
	firsttone = "first tone ";
	third1 = "Use special note lengths? Do you want to use 1/3, 1/5, 1/6, 1/7, 1/9, 1/10, 1/11 or (only) 1/4, 1/8, etc.\n";
	third2 = "\t(0) ask for every note\n\t(1) never use special lengths in this file\n\t(2) never use normal lenghts in this file\n: ";
	third = "Use special lengths for this tone (y/n)? ";
	yes = 'y'; // don't use capitals
	no  = 'n';
	firstlength = "first tone length\n";
	attr1 = "Do you want to use different attributes (sound file, volume curve, etc.) for every sound (y/n)? ";
	attr = "attribute index (1-32): ";
	tone = "tone (1-121) ";
	tonehelp = "1-121, c' is 61, +1 is an upward semitone step, 121 is a rest: ";
	length = "tone length ";
	lasttone = "Is this the last tone (y/n)? ";
	firstval = "first value ";
	time = "time index ";
	val = "value ";
	rise = "slope: ";
	linetype = "following linetype";
	help = "(h for help)";
	high1 = "Value to high ";
	low1 = "Value to low ";
	forlinetype = "for following linetype ";
	nfirstval = ". Please insert new first value ";
	nval = ". Please insert new value ";
	nlinetype = ". Please insert new linetype ";
	minismax1 = "Recent value has to be ";
	minismax2 = ". Set to ";
	parabola_start = "starting x-coordinate for parabola (-8 - 7): ";
	parabola_end = "end x-coordinate for parabola ";
	wtattr = " with these attributes";
	paramp = "amplitude percentage for symmetric parabola: ";
	forvalue = "for recent value. ";
	forlastval = "for last value ";
	andlinetype = "and linetype. ";
	permissible = "Set to maximum possible value";
	oder = "or";		// sorry, "or" doesn't work, I had to take the German word for it
	lastval = "This has to be the last value. Saving as last value.";
}


text_line_help::text_line_help() {
	types = "possible linetypes:\n\t(1) straight line\n\t(2) sine curve, straight beginning\n\t(3) sine curve, curved beginning\n\t(4) gauss curve, \"low\" beginning\n\t(5) gauss curve, \"high\" beginning\n\t(6) part of parabola with positive a\n\t(7) part of parabola with negative a\n\t(0) no line, last value\nlinetype: ";
}

text_length_help::text_length_help() {
	third = "possible \"special\" lenghts:\n\t(1) 1/12\n\t(2) 1/11\n\t(3) 1/10\n\t(4) 1/9\n\t(5) 1/7\n\t(6) 1/6\n\t(7) 1/5\n\t(8) 1/3\n: ";
	normal = "possible \"normal\" lenghts:\n\t(1) 1/16\n\t(2) 1/8\n\t(3) 3/16\n\t(4) 1/4\n\t(5) 3/8\n\t(6) 1/2\n\t(7) 3/4\n\t(8) 1\n: ";
}
